diff --git a/typing/debug_core.mli b/typing/debug_core.mli
new file mode 100644
index 0000000..f8b61dd
--- /dev/null
+++ b/typing/debug_core.mli
@@ -0,0 +1,453 @@
+open Asttypes
+open Types
+
+open Parsetree
+
+(* ppf *)
+val ppf : Format.formatter
+
+(* コンテキストの定義 *)
+type expr_context =
+  | Empty
+  | Lambda of pattern * expr_context
+  | Let of rec_flag * value_binding list * expr_context
+type 'a context_t =
+  ('a * expr_context) * Env.t * (structure_item * Env.t) list
+
+
+module Map : sig
+
+  type 'a map2 = (pattern -> expression -> expression)
+                 -> (pattern -> expression -> pattern)
+                 -> 'a -> 'a
+  type 'a map1 = (expression -> expression) -> (pattern -> pattern)
+                 -> 'a -> 'a
+
+  (* 与える関数が2引数 *)
+  val v2 : value_binding map2
+  val c2 : case map2
+
+  (* 与える関数が1引数 *)
+  val v1 : value_binding map1
+  val c1 : case map1
+  val e1 : expression map1
+  val p1 : pattern map1
+  val le : ('a * expression) map1
+  val lp : ('a * pattern) map1
+
+  (* exp / pat を差し替える *)
+  val set_exp : 'a map1 -> 'a -> expression -> 'a
+  val set_pat : 'a map1 -> 'a -> pattern -> 'a
+
+end
+
+module Hole : sig
+  val item : structure_item
+  val to_exp : expression -> expression
+  val exp : expression
+end
+
+(* module Desc *)
+module Desc : sig
+
+  (* 生成関数の型 *)
+  type 'a make_exp_desc =
+    'a list -> expression -> expression_desc
+  type make_exp_desc2 =
+    expression -> expression -> expression option -> expression_desc
+
+  type 'b make_pat_desc = 'b list -> pattern -> pattern_desc
+
+  (* 生成関数を使って exp / pat の desc を差し替える *)
+  val to_exp :
+    'a make_exp_desc
+    -> 'a list -> expression -> expression
+    -> expression
+  val to_exp2 :
+    make_exp_desc2
+    -> expression -> expression -> expression option -> expression
+    -> expression
+
+  val to_pat : 'b make_pat_desc -> 'b list
+               -> pattern -> pattern -> pattern
+
+  (* pexp_desc の生成 *)
+  (*
+  val e_let : rec_flag -> value_binding make_exp_desc
+  val e_function : case make_exp_desc
+  val e_fun : arg_label -> expression option
+              -> pattern -> expression -> expression_desc
+  val e_apply : (arg_label * expression) make_exp_desc
+  val e_match : case make_exp_desc
+  val e_try : case make_exp_desc
+  val e_tuple : expression make_exp_desc
+  val e_construct : Longident.t loc -> expression make_exp_desc
+  val e_variant : label -> expression make_exp_desc
+  val e_record : (Longident.t loc * expression) make_exp_desc
+  val e_field : Longident.t loc -> expression make_exp_desc
+  val e_setfield : Longident.t loc
+                   -> expression -> expression -> expression_desc
+  val e_array : expression make_exp_desc
+  val e_constraint : core_type -> expression make_exp_desc
+  val e_ifthenelse : expression -> expression
+                     -> expression option -> expression_desc
+  val e_sequence : expression -> expression -> expression_desc
+  *)
+
+  module type Typ =
+    sig
+      type t
+      val internal : t -> t -> bool
+      val leaf : t -> bool
+      val comp : ?mode:bool -> t -> t -> int
+      val map : (t -> t) -> t -> t
+      val map_all : (t -> t) -> t -> t
+      val fold : ('a -> t -> 'a) -> 'a -> t -> 'a
+      val fold_all : ('a -> t -> 'a) -> 'a -> t -> 'a
+      val replace : t -> t -> t
+    end
+
+  module Exp : Typ with type t = expression
+  module Pat : sig
+    include Typ with type t = pattern
+    val find : string -> t -> t
+  end
+  module Vb :
+  sig
+    val complete : (value_binding list) context_t -> (value_binding list)
+  end
+
+  module Str :
+  sig
+    val clear : structure -> structure
+    val output : string -> structure -> unit
+  end
+(*
+  (* ppat_desc の生成 *)
+  val p_alias : string loc -> pattern make_pat_desc
+  val p_tuple : pattern make_pat_desc
+  val p_construct : Longident.t loc -> pattern make_pat_desc
+  val p_variant : label -> pattern make_pat_desc
+  val p_record : closed_flag -> (Longident.t loc * pattern) make_pat_desc
+  val p_array : pattern make_pat_desc
+  val p_or : pattern -> pattern -> pattern_desc
+  val p_constraint : core_type -> pattern make_pat_desc
+
+  val restore : (arg_label * expression) list -> expression -> expression
+  val origin : expression -> expression
+*)
+end
+
+(* module Size  *)
+module Size : sig
+
+  val set_resize : bool
+
+  module type Typ =
+    sig
+      type t
+      val get : t -> int
+      val set : t -> t
+      val reset : int -> t -> t
+      val comp : ?e':t -> t -> int
+    end
+
+  module Exp : Typ with type t = expression
+
+(*
+  val get : int ->  expression -> int
+  val set : expression -> expression
+
+  val reset : expression -> expression
+  val reset1 : (int -> int -> int) -> expression -> expression
+
+  val resize : expression -> expression
+
+  val terminated : expression -> expression
+
+  val is1 : expression -> bool
+
+  val fltr1 : expression -> bool
+  val fltr0 : expression -> bool
+*)
+  val children : expression -> expression list
+(*
+  val get_child :
+    expression ->
+    expression * (expression -> expression) * (expression -> expression)
+
+  val getChild2 :
+    expression ->
+    expression * (expression -> expression) * (expression -> expression)
+  val getChild3 :
+    expression ->
+    expression * (expression -> expression) * (expression -> expression)
+*)
+  val getChildSet :
+    expression -> expression * (bool -> (expression -> expression) -> expression -> expression)
+  val getChildSet2 :
+    expression -> expression * (bool -> (expression -> expression) -> expression -> expression)
+(*
+  val check : expression -> bool
+
+  val get_one : expression -> int
+  val set_one : ?n:int -> expression -> expression
+  val set_all :
+    ('a list -> 'a list -> expression -> 'a Desc.make_exp_desc -> expression)
+    ->'a Desc.make_exp_desc -> ('a -> expression) -> 'a list -> expression
+    -> expression
+
+
+
+  val node_sort : expression -> expression list
+
+*)
+end
+
+(* module Abst *)
+(*
+module Abst : sig
+  module type Typ =
+    sig
+      type t
+      val hole : t -> t
+    end
+
+  module Exp : Typ with type t = expression
+
+  val set_one : expression -> expression list
+  val set_all : expression -> expression
+
+  val get : expression -> bool -> expression -> expression
+
+  val exp : expression -> expression
+
+end
+*)
+
+module Meta : sig
+
+  val clean : string -> expression -> expression
+
+end
+
+
+(* 型デバッガが訪れるノード数カウント用の変数 (debug_main.ml) *)
+
+val print_node_count : bool
+val print_asked_expr : bool
+
+(* スライス表示用変数 (debug_slice.ml) *)
+
+val print_slice : bool
+
+(* OCaml のエラーメッセージ Errors.report_error 制御用変数
+   (toplevel/toploop.ml, driver/compile.ml) *)
+
+val print_ocaml_error : bool
+
+(* スライスをするかどうかを制御する変数
+   (debug_slice.ml, debug_main.ml) *)
+
+val on_slice : bool
+val on_pat_slice : bool ref
+
+(* 各種情報をログに出力するかを制御する変数
+   (debug_core.ml, debug_slice.ml) *)
+val on_file_output : bool
+
+(* 表示用関数 *)
+val print_deb_exp : Format.formatter -> expression -> unit
+val print_deb_strs : Format.formatter -> structure -> unit
+
+(* 抽象化した構文
+   (debug_slice.ml, debug_main.ml) *)
+val dummy_int0 : expression
+val skeleton : expression
+val wildcard : pattern
+val dummy_fun : expression
+val dummy_assertfalse : expression -> expression
+val dummy_any : pattern -> pattern
+
+(* desc の置換を行う関数 *)
+val desc_to_exp : expression_desc -> expression -> expression
+val desc_to_pat : pattern_desc -> pattern -> pattern
+
+(* type_expr を扱う関数 *)
+val decode_labels : type_expr -> (structure_item * Env.t) list -> label_declaration list
+val split_arrow : type_expr -> (type_expr * type_expr) option
+
+val decode_tuple : type_expr -> type_expr list option
+
+(* デバッガの処理を行う関数
+   (debug_slice.ml, debug_main.ml) *)
+val pattern_variables : pattern -> string list
+val plug_expr : expression -> expr_context -> expression
+val plug_str : (expression * expr_context) -> structure
+
+val judge : expression context_t -> (string context_t * type_expr) list * type_expr 
+
+
+val skeleton' : expression
+val hole_str : structure_item
+
+val hole_of_exp : expression -> expression
+val hole_of_pat : pattern -> pattern
+
+module Data : sig
+  val log_path : string
+  val express_mode : int
+  (* DEBUGGER_EXPRESS_MODE
+     98 : スライスの出力
+     99 : コンパイラのエラーメッセージ出力
+     100 : デバッガと対話
+
+     終了番号
+     ~99 : DEBUGGER_EXPRESS_MODEによる停止
+     100 : デバッガの質問内容を出力
+     101~ : デバッガのエラーメッセージ出力（予定）
+  *)
+
+  module Loc : sig
+    val printJSON : Format.formatter -> Location.t -> unit
+  end
+
+  module Buffer : sig
+    val write : string -> expression -> string -> unit
+  end
+
+  module Slice : sig
+    module Exp :
+    sig
+      val write : expression -> unit
+      val outputs : unit -> unit
+    end
+  end
+
+  module Infer : sig
+    val init : string -> unit
+    val read : Location.t -> unit
+    val write : structure -> expression -> bool -> unit
+  end
+
+  val init : expression context_t -> expression
+
+  val typed : Env.t ->
+    ((expression -> expression) -> expression -> structure)
+    -> (expression -> expression) -> expression -> bool
+
+  val finally : expression -> float -> expression
+
+end
+
+(*
+module Library :
+sig
+
+  module type Abst_t =
+    sig
+      type t
+      val skeleton : t
+      val terminate : t -> t
+      val of_desc : t -> t
+      val of_attr : t -> t
+      val to_loc : t -> Location.t
+    end
+
+  module type Modules =
+    sig
+      type s
+      val internal : s -> s -> bool
+      val pos_start : s -> string * (int * int)
+      val pos_end : s -> string * (int * int)
+      val pos_ghost : s -> bool
+      val pos_all : s -> (string * ((int * int) * (int * int))) * bool
+
+      val print : bool -> Format.formatter -> s -> unit
+
+      module Desc : Desc.Typ with type t = s
+      module Hole : sig
+        include Abst_t with type t = s
+        val root : s -> s
+        val node : s -> s
+      end
+    end
+
+  val expression : (module Modules with type s = expression)
+end
+
+(*
+module Node :
+sig
+  type loc_t = {
+    line : int;
+    char : int;
+  }
+  type pos_t = {
+    filename : string;
+    s : loc_t;
+    e : loc_t;
+  }
+  type slice_t = {
+    pos : pos_t;
+    ghost : int;
+  }
+  type buffer_t = {
+    scope : string option;
+    typ : bool * pos_t;
+  }
+  type infer_t = {
+    section : (float * bool option) list;
+    total : float;
+    root : expression;
+  }
+
+  type t = {
+    userID : string option; (* ユーザID。node の実行に必要 *)
+    date : string option; (* 日時 *)
+    slice : slice_t list; (* 既存のスライス情報 *)
+    buffer : buffer_t list; (* ユーザの回答 *)
+    infer : infer_t list; (* 型推論の記録 *)
+  }
+
+  module Null :
+  sig
+    val loc : loc_t
+    val pos : pos_t
+    val slice : slice_t
+  end
+
+  (* flg の設定 *)
+  module Input :
+  sig
+    val err : exn -> unit
+    val node : expression -> int * int * type_expr option -> unit
+    val ask : ?scope:string -> expression -> type_expr -> unit
+    val expr : expression * type_expr -> unit
+    val result : int -> expression context_t -> unit
+  end
+
+  module Output :
+  sig
+    val f : unit -> unit
+    val buffer : buffer_t -> unit
+    val slicer : expression -> t -> int * (expression * expression) list -> unit
+  end
+
+  module Check :
+  sig
+    val slice : t -> bool
+    val json : unit -> bool (* node.js 用の出力の有無 *)
+  end
+
+  val init : unit -> t ref
+  val typed : t ref -> Env.t -> structure -> bool
+
+  val yes : expression -> attribute
+  val no : expression -> attribute
+
+  val of_exp : t -> expression -> expression
+end
+
+*)
+*)
diff --git a/typing/debug_main.mli b/typing/debug_main.mli
new file mode 100644
index 0000000..789cb13
--- /dev/null
+++ b/typing/debug_main.mli
@@ -0,0 +1,3 @@
+open Parsetree
+
+val launch : exn -> structure -> (unit -> Env.t) -> unit
